Version bump #363521 by Attila Jecs. Rewrite init.d script to only work with openrc...
authorMike Frysinger <vapier@gentoo.org>
Sun, 13 Nov 2011 04:18:38 +0000 (04:18 +0000)
committerMike Frysinger <vapier@gentoo.org>
Sun, 13 Nov 2011 04:18:38 +0000 (04:18 +0000)
Package-Manager: portage-2.2.0_alpha74/cvs/Linux x86_64

sys-fs/cryptsetup/ChangeLog
sys-fs/cryptsetup/Manifest
sys-fs/cryptsetup/cryptsetup-1.4.1.ebuild [new file with mode: 0644]
sys-fs/cryptsetup/files/dmcrypt.rc [new file with mode: 0755]

index 9cde2fdd06f3b76d6ce374edd3943b0a3903ada0..55832e4c8a367e934737ada635e544097c02c9b6 100644 (file)
@@ -1,6 +1,14 @@
 # ChangeLog for sys-fs/cryptsetup
 # Copyright 1999-2011 Gentoo Foundation; Distributed under the GPL v2
-# $Header: /var/cvsroot/gentoo-x86/sys-fs/cryptsetup/ChangeLog,v 1.118 2011/09/19 01:33:47 vapier Exp $
+# $Header: /var/cvsroot/gentoo-x86/sys-fs/cryptsetup/ChangeLog,v 1.119 2011/11/13 04:18:38 vapier Exp $
+
+*cryptsetup-1.4.1 (13 Nov 2011)
+
+  13 Nov 2011; Mike Frysinger <vapier@gentoo.org> +cryptsetup-1.4.1.ebuild,
+  +files/dmcrypt.rc:
+  Version bump #363521 by Attila Jecs. Rewrite init.d script to only work with
+  openrc. Tweak init.d for splash support #386563 by Tim Ruffing, and make a
+  bit more POSIX compliant #255528 by Martin Väth.
 
   19 Sep 2011; Mike Frysinger <vapier@gentoo.org> cryptsetup-1.2.0-r1.ebuild:
   Simplify deps a little more, and require static-libs with lvm2 #383417 by
index aaa1a79a32e23d808d37ef9de34ad0ee44c76df6..37ee6204e8e8e55deedc3535eb81f331727f7fcf 100644 (file)
@@ -10,20 +10,23 @@ AUX 1.1.0_rc3-static-no-selinux.patch 813 RMD160 a9e476edd9bfe12e4663962198e3ed2
 AUX 1.1.3-dm-crypt-start.sh 8651 RMD160 618342317373f3a19f200addfb2e528ced25e9e3 SHA1 ea59b43866a7799d081d628eaed624323a6fa16c SHA256 1489ce5480d51beb81cf4f5178468ad4b2f2e4b3f53bc75ee8fe47d3e050a76a
 AUX 1.1.3-dm-crypt-stop.sh 1272 RMD160 f91d025777670423d572018a08429805b828688f SHA1 c91e44f75231554c8129b7c3538eae2850ba67b9 SHA256 c81bf0cf8e57b3f83f55c808dba619b0a0f60eef8c3ed406d266be7cecdf96f9
 AUX cryptsetup-1.0.6-udevsettle.patch 561 RMD160 613da67876c1c20c3ea3687ec425b31551ae57d1 SHA1 cd0177fa53f4d6f605522f53a98c57286162859f SHA256 80c4914071769dedc20198425b4ea528ec22264ff4c54516a9e5722a8e671f60
+AUX dmcrypt.rc 9093 RMD160 76f2434a62cac6ad3fa11f24fff26b72bc4a1f75 SHA1 c827ca8e7e8b1f090463b430aa6ead8c791fb80b SHA256 f63e7690e9f9aea0d36565dac4aff7614a2542d79d7c6ec99611faa34009d912
 DIST cryptsetup-1.0.6.tar.bz2 405713 RMD160 7ec056cf80fd25a782d3f6cc345858cf4ea988ec SHA1 dd45ad6a29c2e9af83c2c1525b02d7af88ab7212 SHA256 df7fda80cfa01f063caf39140287a47d018dfe056fc71a3ba605e690ff0183fd
 DIST cryptsetup-1.1.2.tar.bz2 478501 RMD160 2488fb603edb73cfc99726c59d44530ac006b4d9 SHA1 270580572c413facee359b29e5886ff2b4e6de1c SHA256 45972839fbb169b3ad5649454c217b7f5b0b3c8bf07e32f51a334a88217c7293
 DIST cryptsetup-1.1.3.tar.bz2 499276 RMD160 bf2e724779174a3cd6ce9d592e17c70979f26e85 SHA1 6f8a4c9a80a0d25f8492dfce6db6abed221598f6 SHA256 9c8e68a272f6d9cfb6cd65cc0743f4c44a2096c61f74e0602bf40208b5e69c0a
 DIST cryptsetup-1.2.0.tar.bz2 523859 RMD160 8f1ce6d72a056e9c98996be85041569e96abff24 SHA1 fa9383eda40655311f2dfe751e061b0111c73908 SHA256 411129817ff29e6a957bcbdcd9a2c4c953c1539acd8af912c383262ba901b5ea
+DIST cryptsetup-1.4.1.tar.bz2 772971 RMD160 4c8a7e1a3a7bd7f2d52591c1b8de21a31edeb780 SHA1 32608be5b146a7bd3999129b086bad8b66c085b9 SHA256 82b143328c2b427ef2b89fb76c701d311c95b54093c21bbf22342f7b393bddcb
 EBUILD cryptsetup-1.0.6-r2.ebuild 3150 RMD160 997496f32ffb972a4d21efb80cb0ccedf2a53197 SHA1 8cbe4f6a69a72faf4916f1992a4ee3febd04114e SHA256 cad92c053518bb11a2acd9e806e471117c462187c8a02f5258e933e093ab2a66
 EBUILD cryptsetup-1.1.2.ebuild 3382 RMD160 c737fb8fb63a11c15c1af86db25fafc8a32e152a SHA1 4cc2311e92c429d519d99c126434b4e2ca6375cf SHA256 6445f68c8a2f1497a771cc07466f0ee6a0b23cdeb257c7db2899a1f7b247d452
 EBUILD cryptsetup-1.1.3-r3.ebuild 3364 RMD160 a4e497ae62cc974350460446b173fb3d092afc28 SHA1 e640b856ab39e456ed194da62fe0cf0dc11d76ab SHA256 54733ac01c0e2ec02c02ec6f13e50a24452cf1d7c93135a5bf8141129687ab52
 EBUILD cryptsetup-1.2.0-r1.ebuild 3628 RMD160 98044dce88847e72e1778482bef3ddcc600bae52 SHA1 60a007d06de6b05f78f03b9a4488ca9b463aa446 SHA256 0dff751d075bb47c26c9dd3426f86da7e8e717b08a5daa7dfd05affc509e0b6e
-MISC ChangeLog 17385 RMD160 bd00202024361bfc9eac4c2a6e727340cdb8677e SHA1 7f159c930f07eb34636dd67b4af78740c83b5c2a SHA256 d5265945a7cf3a42db8e229882f46fe10ac0811ebaa59ebb194bbad790b567c8
+EBUILD cryptsetup-1.4.1.ebuild 3341 RMD160 6d15ae374171f64238b9c6af3666cb0c047630ce SHA1 3636ff5dd8ed0ddfae8aa66219eab8952c8de971 SHA256 7546810205e67cff8c86614e466ccacb04b6a879d8485cd429fa22562051bb9f
+MISC ChangeLog 17724 RMD160 a9c0e9dfd791ac539e40ab2ca71a6b26eff97a40 SHA1 b3355853774691d78ff824775a05e22543763896 SHA256 67e90c7749f854e918d321ffe595081720c0062f896aae1c7cbf2f337b738a3e
 MISC metadata.xml 239 RMD160 81512c49e64b6e70c7b746ba09d3e6fce4c7bc89 SHA1 c4085a72e46fe6bcea5bdff780007791eae6db4b SHA256 aebd5282fb892100f348eba1ed27edd27e7296356897c6f5314674f8abb4b51a
 -----BEGIN PGP SIGNATURE-----
-Version: GnuPG v2.0.17 (GNU/Linux)
+Version: GnuPG v2.0.18 (GNU/Linux)
 
-iF4EAREIAAYFAk52nAIACgkQaC/OocHi7Jb9NQEAl5/i/VZRMNSfuxNWMq/W4pbN
-XTvrQ86nhw1paKL6FooA+wRDFoMC0uPSjcAjnsd+TWRHRcKPT0ZsGMe/M75+3/Qi
-=Ft4/
+iF4EAREIAAYFAk6/RSUACgkQaC/OocHi7JZ1egD/Z2+bSlLP+UI3LP+yQDNyiFuR
+decMOSSYF4eU2CJ7eA4BAJZQghOQlxUdo53zVU74KnLItPbB3wO2pUR0Essds50F
+=T2ex
 -----END PGP SIGNATURE-----
diff --git a/sys-fs/cryptsetup/cryptsetup-1.4.1.ebuild b/sys-fs/cryptsetup/cryptsetup-1.4.1.ebuild
new file mode 100644 (file)
index 0000000..33c27a3
--- /dev/null
@@ -0,0 +1,102 @@
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/sys-fs/cryptsetup/cryptsetup-1.4.1.ebuild,v 1.1 2011/11/13 04:18:38 vapier Exp $
+
+EAPI="2"
+
+inherit linux-info libtool
+
+MY_P=${P/_rc/-rc}
+DESCRIPTION="Tool to setup encrypted devices with dm-crypt"
+HOMEPAGE="http://code.google.com/p/cryptsetup/"
+SRC_URI="http://cryptsetup.googlecode.com/files/${MY_P}.tar.bz2"
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86"
+IUSE="nls selinux +static"
+
+S=${WORKDIR}/${MY_P}
+
+RDEPEND="!<sys-apps/baselayout-2
+       !static? (
+               >=dev-libs/libgcrypt-1.1.42
+               dev-libs/libgpg-error
+               >=dev-libs/popt-1.7
+               >=sys-apps/util-linux-2.17.2
+               >=sys-fs/lvm2-2.02.64
+       )
+       >=sys-fs/udev-124
+       >=sys-libs/e2fsprogs-libs-1.41
+       selinux? ( sys-libs/libselinux )
+       !sys-fs/cryptsetup-luks"
+DEPEND="${RDEPEND}
+       static? (
+               >=dev-libs/libgpg-error-1.10[static-libs]
+               >=dev-libs/popt-1.16-r1[static-libs]
+               || ( >=sys-apps/util-linux-2.20[static-libs] <sys-apps/util-linux-2.20 )
+               dev-libs/libgcrypt[static-libs]
+               || ( >=sys-fs/lvm2-2.02.88[static-libs] <sys-fs/lvm2-2.02.88 )
+       )"
+
+pkg_setup() {
+       local CONFIG_CHECK="~DM_CRYPT ~CRYPTO ~CRYPTO_CBC"
+       local WARNING_DM_CRYPT="CONFIG_DM_CRYPT:\tis not set (required for cryptsetup)\n"
+       local WARNING_CRYPTO_CBC="CONFIG_CRYPTO_CBC:\tis not set (required for kernel 2.6.19)\n"
+       local WARNING_CRYPTO="CONFIG_CRYPTO:\tis not set (required for cryptsetup)\n"
+       check_extra_config
+}
+
+src_prepare() {
+       sed -i '/^LOOPDEV=/s:$: || exit 0:' tests/{compat,mode}-test
+       elibtoolize
+}
+
+src_configure() {
+       econf \
+               --sbindir=/sbin \
+               --enable-shared \
+               $(use_enable static static-cryptsetup) \
+               $(use_enable nls) \
+               $(use_enable selinux)
+}
+
+src_test() {
+       if [[ ! -e /dev/mapper/control ]] ; then
+               ewarn "No /dev/mapper/control found -- skipping tests"
+               return 0
+       fi
+       default
+}
+
+src_install() {
+       emake DESTDIR="${D}" install || die
+       use static && { mv "${D}"/sbin/cryptsetup{.static,} || die ; }
+       dodoc TODO ChangeLog README NEWS
+
+       newconfd "${FILESDIR}"/1.0.6-dmcrypt.confd dmcrypt || die
+       newinitd "${FILESDIR}"/dmcrypt.initd dmcrypt || die
+}
+
+pkg_postinst() {
+       ewarn "This ebuild introduces a new set of scripts and configuration"
+       ewarn "than the last version. If you are currently using /etc/conf.d/cryptfs"
+       ewarn "then you *MUST* copy your old file to:"
+       ewarn "/etc/conf.d/dmcrypt"
+       ewarn "Or your encrypted partitions will *NOT* work."
+       elog "Please see the example for configuring a LUKS mountpoint"
+       elog "in /etc/conf.d/dmcrypt"
+       elog
+       elog "If you are using baselayout-2 then please do:"
+       elog "rc-update add dmcrypt boot"
+       elog "This version introduces a command line arguement 'key_timeout'."
+       elog "If you want the search for the removable key device to timeout"
+       elog "after 10 seconds add the following to your bootloader config:"
+       elog "key_timeout=10"
+       elog "A timeout of 0 will mean it will wait indefinitely."
+       elog
+       elog "Users using cryptsetup-1.0.x (dm-crypt plain) volumes must use"
+       elog "a compatibility mode when using cryptsetup-1.1.x. This can be"
+       elog "done by specifying the cipher (-c), key size (-s) and hash (-h)."
+       elog "For more info, see http://code.google.com/p/cryptsetup/wiki/FrequentlyAskedQuestions#6._Issues_with_Specific_Versions_of_cryptsetup"
+}
diff --git a/sys-fs/cryptsetup/files/dmcrypt.rc b/sys-fs/cryptsetup/files/dmcrypt.rc
new file mode 100755 (executable)
index 0000000..07ccd84
--- /dev/null
@@ -0,0 +1,339 @@
+#!/sbin/runscript
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/sys-fs/cryptsetup/files/dmcrypt.rc,v 1.1 2011/11/13 04:18:38 vapier Exp $
+
+depend() {
+       before checkfs fsck
+}
+
+# We support multiple dmcrypt instances based on $SVCNAME
+execute_hook="dm_crypt_execute_dmcrypt"
+# XXX: Should we drop this ?
+# execute_hook="dm_crypt_execute_localmount"
+conf_file="/etc/conf.d/${SVCNAME}"
+
+# Get splash helpers if available.
+if [ -e /sbin/splash-functions.sh ] ; then
+       . /sbin/splash-functions.sh
+fi
+
+# Setup mappings for an individual target/swap
+# Note: This relies on variables localized in the main body below.
+dm_crypt_execute_dmcrypt() {
+       local dev ret mode foo
+
+       if [ -n "${target}" ] ; then
+               # let user set options, otherwise leave empty
+               : ${options:=' '}
+       elif [ -n "${swap}" ] ; then
+               if cryptsetup isLuks ${source} 2>/dev/null ; then
+                       ewarn "The swap you have defined is a LUKS partition. Aborting crypt-swap setup."
+                       return
+               fi
+               target=${swap}
+               # swap contents do not need to be preserved between boots, luks not required.
+               # suspend2 users should have initramfs's init handling their swap partition either way.
+               : ${options:='-c aes -h sha1 -d /dev/urandom'}
+               : ${pre_mount:='mkswap ${dev}'}
+       else
+               return
+       fi
+       if [ -z "${source}" ] && [ ! -e "${source}" ] ; then
+               ewarn "source \"${source}\" for ${target} missing, skipping..."
+               return
+       fi
+
+       if [ -n "${loop_file}" ] ; then
+               dev="/dev/mapper/${target}"
+               ebegin "  Setting up loop device ${source}"
+               losetup ${source} ${loop_file}
+       fi
+
+       # cryptsetup:
+       # luksOpen <device> <name>      # <device> is $source
+       # create   <name>   <device>    # <name>   is $target
+       local arg1="create" arg2="${target}" arg3="${source}" luks=0
+
+       cryptsetup isLuks ${source} 2>/dev/null && { arg1="luksOpen"; arg2="${source}"; arg3="${target}"; luks=1; }
+
+       # Older versions reported:
+       #       ${target} is active:
+       # Newer versions report:
+       #       ${target} is active[ and is in use.]
+       if cryptsetup status ${target} | egrep -q ' is active' ; then
+               einfo "dm-crypt mapping ${target} is already configured"
+               return
+       fi
+       splash svc_input_begin ${SVCNAME} >/dev/null 2>&1
+
+       # Handle keys
+       if [ -n "${key}" ] ; then
+               read_abort() {
+                       # some colors
+                       local red='\x1b[31;01m' green='\x1b[32;01m' off='\x1b[0;0m'
+                       local ans
+                       local prompt=" ${green}*${off}  $1? (${red}yes${off}/${green}No${off}) "
+                       shift
+                       [ -z "${NORMAL}" ] && eval $(eval_ecolors)
+                       einfon "  $1? (${WARN}yes${NORMAL}/${GOOD}No${NORMAL}) "
+                       if ! read -n 1 $* ans ; then
+                               printf '\r'
+                       else
+                               echo
+                       fi
+                       case ${ans} in
+                               [yY]|[yY][eE][sS]) return 0;;
+                               *) return 1;;
+                       esac
+               }
+
+               # Notes: sed not used to avoid case where /usr partition is encrypted.
+               mode=${key/*:/} && ( [ "${mode}" = "${key}" ] || [ -z "${mode}" ] ) && mode=reg
+               key=${key/:*/}
+               case "${mode}" in
+               gpg|reg)
+                       # handle key on removable device
+                       if [ -n "${remdev}" ] ; then
+                               # temp directory to mount removable device
+                               local mntrem="${RC_SVCDIR}/dm-crypt-remdev.$$"
+                               if [ ! -d "${mntrem}" ] ; then
+                                       if ! mkdir -p "${mntrem}" ; then
+                                               ewarn "${source} will not be decrypted ..."
+                                               einfo "Reason: Unable to create temporary mount point '${mntrem}'"
+                                               return
+                                       fi
+                               fi
+                               i=0
+                               einfo "Please insert removable device for ${target}"
+                               while [ ${i} -lt ${dmcrypt_max_timeout:-120} ] ; do
+                                       foo=""
+                                       if mount -n -o ro "${remdev}" "${mntrem}" 2>/dev/null >/dev/null ; then
+                                               # keyfile exists?
+                                               if [ ! -e "${mntrem}${key}" ] ; then
+                                                       umount -n "${mntrem}"
+                                                       rmdir "${mntrem}"
+                                                       einfo "Cannot find ${key} on removable media."
+                                                       read_abort "Abort" ${read_timeout:--t 1} && return
+                                               else
+                                                       key="${mntrem}${key}"
+                                                       break
+                                               fi
+                                       else
+                                               [ -e "${remdev}" ] \
+                                                       && foo="mount failed" \
+                                                       || foo="mount source not found"
+                                       fi
+                                       : $((i += 1))
+                                       read_abort "Stop waiting after $i attempts (${foo})" -t 1 && return
+                               done
+                       else    # keyfile ! on removable device
+                               if [ ! -e "${key}" ] ; then
+                                       ewarn "${source} will not be decrypted ..."
+                                       einfo "Reason: keyfile ${key} does not exist."
+                                       return
+                               fi
+                       fi
+                       ;;
+               *)
+                       ewarn "${source} will not be decrypted ..."
+                       einfo "Reason: mode ${mode} is invalid."
+                       return
+                       ;;
+               esac
+       else
+               mode=none
+       fi
+       ebegin "  ${target} using: ${options} ${arg1} ${arg2} ${arg3}"
+       if [ "${mode}" = "gpg" ] ; then
+               : ${gpg_options:='-q -d'}
+               # gpg available ?
+               if type -p gpg >/dev/null ; then
+                       for (( i = 0 ; i < 3 ; i += 1 )) ; do
+                               # paranoid, don't store key in a variable, pipe it so it stays very little in ram unprotected.
+                               # save stdin stdout stderr "values"
+                               gpg ${gpg_options} ${key} 2>/dev/null | cryptsetup ${options} ${arg1} ${arg2} ${arg3}
+                               ret=$?
+                               [ ${ret} -eq 0 ] && break
+                       done
+                       eend ${ret} "failure running cryptsetup"
+               else
+                       ewarn "${source} will not be decrypted ..."
+                       einfo "Reason: cannot find gpg application."
+                       einfo "You have to install app-crypt/gnupg first."
+                       einfo "If you have /usr on its own partition, try copying gpg to /bin ."
+               fi
+       else
+               if [ "${mode}" = "reg" ] ; then
+                       cryptsetup ${options} -d ${key} ${arg1} ${arg2} ${arg3}
+                       ret=$?
+                       eend ${ret} "failure running cryptsetup"
+               else
+                       cryptsetup ${options} ${arg1} ${arg2} ${arg3}
+                       ret=$?
+                       eend ${ret} "failure running cryptsetup"
+               fi
+       fi
+       if [ -d "${mntrem}" ] ; then
+               umount -n ${mntrem} 2>/dev/null >/dev/null
+               rmdir ${mntrem} 2>/dev/null >/dev/null
+       fi
+       splash svc_input_end ${SVCNAME} >/dev/null 2>&1
+
+       if [ ${ret} -ne 0 ] ; then
+               cryptfs_status=1
+       else
+               if [ -n "${pre_mount}" ] ; then
+                       dev="/dev/mapper/${target}"
+                       ebegin "    pre_mount: ${pre_mount}"
+                       eval "${pre_mount}" > /dev/null
+                       ewend $? || cryptfs_status=1
+               fi
+       fi
+}
+
+# Run any post_mount commands for an individual mount
+#
+# Note: This relies on variables localized in the main body below.
+dm_crypt_execute_localmount() {
+       local mount_point
+
+       [ -z "${target}" ] && [ -z "${post_mount}" ] && return
+
+       if ! cryptsetup status ${target} | egrep -q '\<active:' ; then
+               ewarn "Skipping unmapped target ${target}"
+               cryptfs_status=1
+               return
+       fi
+
+       mount_point=$(grep "/dev/mapper/${target}" /proc/mounts | cut -d' ' -f2)
+       if [ -z "${mount_point}" ] ; then
+               ewarn "Failed to find mount point for ${target}, skipping"
+               cryptfs_status=1
+       fi
+
+       if [ -n "${post_mount}" ] ; then
+               ebegin "Running post_mount commands for target ${target}"
+               eval "${post_mount}" >/dev/null
+               eend $? || cryptfs_status=1
+       fi
+}
+
+# Lookup optional bootparams
+get_bootparam_val() {
+       # We're given something like:
+       #    foo=bar=cow
+       # Return the "bar=cow" part.
+       case $1 in
+       *\=*)
+               local key=$(echo "$1" | cut -f1 -d=)
+               echo "$1" | cut -c $(( ${#key} + 2 ))
+               ;;
+       esac
+}
+
+start() {
+       local header=true cryptfs_status=0
+       local gpg_options key loop_file target targetline options pre_mount post_mount source swap remdev
+
+       local x
+       for x in $(cat /proc/cmdline) ; do
+               case "${x}" in
+               key_timeout\=*)
+                       local KEY_TIMEOUT=$(get_bootparam_val "${x}")
+                       if [ ${KEY_TIMEOUT} -gt 0 ] ; then
+                               read_timeout="-t ${KEY_TIMEOUT}"
+                       fi
+               ;;
+               esac
+       done
+
+       while read -u 3 targetline ; do
+               case ${targetline} in
+               # skip comments and blank lines
+               ""|"#"*) continue ;;
+               # skip service-specific openrc configs #377927
+               rc_*) continue ;;
+               esac
+
+               ${header} && ebegin "Setting up dm-crypt mappings"
+               header=false
+
+               # check for the start of a new target/swap
+               case ${targetline} in
+               target=*|swap=*)
+                       # If we have a target queued up, then execute it
+                       ${execute_hook}
+
+                       # Prepare for the next target/swap by resetting variables
+                       unset gpg_options key loop_file target options pre_mount post_mount source swap remdev
+                       ;;
+
+               gpg_options=*|remdev=*|key=*|loop_file=*|options=*|pre_mount=*|post_mount=*|source=*)
+                       if [ -z "${target}${swap}" ] ; then
+                               ewarn "Ignoring setting outside target/swap section: ${targetline}"
+                               continue
+                       fi
+                       ;;
+
+               dmcrypt_max_timeout=*)
+                       # ignore global options
+                       continue
+                       ;;
+
+               *)
+                       ewarn "Skipping invalid line in ${conf_file}: ${targetline}"
+                       ;;
+               esac
+
+               # Queue this setting for the next call to dm_crypt_execute_xxx
+               eval "${targetline}"
+       done 3< ${conf_file}
+
+       # If we have a target queued up, then execute it
+       ${execute_hook}
+
+       ewend ${cryptfs_status} "Failed to setup dm-crypt devices"
+}
+
+stop() {
+       local line header
+
+       # Break down all mappings
+       header=true
+       egrep "^(target|swap)=" ${conf_file} | \
+       while read line ; do
+               ${header} && einfo "Removing dm-crypt mappings"
+               header=false
+
+               target= swap=
+               eval ${line}
+
+               [ -n "${swap}" ] && target=${swap}
+               if [ -z "${target}" ] ; then
+                       ewarn "invalid line in ${conf_file}: ${line}"
+                       continue
+               fi
+
+               ebegin "  ${target}"
+               cryptsetup remove ${target}
+               eend $?
+       done
+
+       # Break down loop devices
+       header=true
+       grep '^source=./dev/loop' ${conf_file} | \
+       while read line ; do
+               ${header} && einfo "Detaching dm-crypt loop devices"
+               header=false
+
+               source=
+               eval ${line}
+
+               ebegin "  ${source}"
+               losetup -d "${source}"
+               eend $?
+       done
+
+       return 0
+}